/**
* <ul>
* Android Tutorial, An <strong>ST Informatique Services</strong>'s project.</br>
* Produced by <strong>Dr. Mathias SEGUY</strong> with the smart contribution of <strong>Julien PAPUT</strong>.</br>
* Delivered by <strong>http://android2ee.com/</strong></br>
* Belongs to <strong>http://stinfoservices.net/</strong></br>
* ****************************************************************************************************************</br>
* This code is free for any usage but can't be distribute.</br>
* The distribution is reserved to the site <strong>http://android2ee.com</strong>.</br>
* The intelectual property belongs to the company <strong>ST Informatique Services</strong>.</br>
* <em>http://stinfoservices.net/</em></br>
* </br>
* For any information (Advice, Expertise, J2EE or Android Training, Rates, Business):</br>
* <em>android@stinfoservices.net</em></br>
* *****************************************************************************************************************</br>
* Ce code est libre de toute utilisation mais n'est pas distribuable.</br>
* Sa distribution est reservée au site <strong>http://android2ee.com</strong>.</br>
* Sa propriété intellectuelle appartient à la société <strong>ST Informatique Services</strong>.</br>
* <em>http://stinfoservices.net/</em></br>
* </br>
* Pour tous renseignements (Conseil, Expertise, Formations J2EE ou Android, Prestations, Forfaits):</br>
* <em>android@stinfoservices.net</em></br>
* *****************************************************************************************************************</br>
* Les meilleurs des Ingénieurs Java-J2EE nous rejoignent pour participer avec nous à la grande aventure</br>
* de l’informatique des prochaines décennies.</br>
* N'hésitez pas à nous contacter.</br>
* *****************************************************************************************************************</br>
* net.stinfoservices.android.tuto</br>
* 25 mars 2011</br>
*/
package stinfoservices.net.android.tuto;

import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import android.app.Activity;
import android.os.Bundle;
import android.webkit.WebView;
import android.widget.Toast;

/**
 * @author sti (Julien PAPUT sous la direction du Dr. Mathias S�guy)
 * @goals This class aims to:
 *        <ul>
 *        <li>This class show the Toulouse Forecast</li>
 *        </ul>
 */
public class WebServiceAccessTuto extends Activity {

	/******************************************************************************************/
	/** Attributes **************************************************************************/
	/******************************************************************************************/
	/** Thr url to use */
	private final String url = "http://www.google.com/ig/api?weather=Toulouse";
	/** The browser to display the result */
	private WebView browser;
	/** The object used to communicate with http */
	private HttpClient client;
	/** The Forecast array */
	private final List<Forecast> forecasts = new ArrayList<Forecast>();
	/** The HTML page */
	private String page;
	/** The raw xml answer	 */
	private String responseBody;
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// instanciate the browser
		browser = (WebView) findViewById(R.id.webkit);
		// instanciate the http communication
		client = new DefaultHttpClient();
		
		// get Toulouse Forecast
		getForecast();

		// build the HTML page to be displayed to the use
		page = generatePage();		
		// update the data displayed by the broser
		browser.loadDataWithBaseURL(null,page, "text/html", "UTF-8", null);
		
	}

	/**
	 * 
	 */
	private void getForecast() {
		// The HTTP get method send to the URL
		HttpGet getMethod = new HttpGet(url);
		// The basic response handler
		ResponseHandler<String> responseHandler = new BasicResponseHandler();
		try {
			// Call the URL and get the response body
			responseBody = client.execute(getMethod, responseHandler);
			// parse the response body
			buildForecasts(responseBody);
		} catch (Throwable t) {
			Toast.makeText(this, "La requete a echouee: " + t.toString(), Toast.LENGTH_LONG).show();
		}
	}

	/**
	 * To generate the HTML page
	 * 
	 * @return the page that display the forecast
	 */
	private String generatePage() {
		StringBuffer bufResult = new StringBuffer(getResources().getString(R.string.html_head));
		String tempLine;
		for (Forecast forecast : forecasts) {
			tempLine=String.format(getResources().getString(R.string.html_loop),forecast.getDay(),forecast.getLowTemp(),forecast.getHighTemp(),forecast.getIcon());
			bufResult.append(tempLine);
		}
		bufResult.append(getResources().getString(R.string.html_foot));
		
		Toast.makeText(this, bufResult, 20000).show();
		Toast.makeText(this, R.string.html_loop, 20000).show();
		Toast.makeText(this, R.string.html_foot, 20000).show();
		
		return bufResult.toString();
		
		
		//StringBuffer bufResult = new StringBuffer("<html><body><table>");
		//bufResult.append("<tr><th width=\"50%\">Jour</th>"
		//		+ "<th>Basse</th><th>Haute</th><th>Tendance</th></tr>");
		//for (Forecast forecast : forecasts) {
		//	bufResult.append("<tr><td align=\"center\">");
		//	bufResult.append(forecast.getDay());
		//	bufResult.append("</td><td align=\"center\">");
		//	bufResult.append(forecast.getLowTemp());
		//	bufResult.append("�C</td>");
		//	bufResult.append("</td><td align=\"center\">");
		//	bufResult.append(forecast.getHighTemp());
		//	bufResult.append("�C</td><td><img src=\"");
		//	bufResult.append(forecast.getIcon());
		//	bufResult.append("\"></td></tr>");
		//}
		//bufResult.append("</table></body></html>");
		//return (bufResult.toString());
	}

	/** This methode build the Forecast correctly */
	private void buildForecasts(String raw) throws ParserConfigurationException, Exception,
			Exception {
		// Using the DOM API: Create the document builder
		DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		// Create the Dom Document by parsing the HTTP response
		Document doc = builder.parse(new InputSource(new StringReader(raw)));
		// Load the nodeList associated to the forcast_condition nodes
		NodeList forecastList = doc.getElementsByTagName("forecast_conditions");
		// Browse those nodes and build the associated forcast by reading the Xml
		for (int i = 0; i < forecastList.getLength(); i++) {
			Element currentFore = (Element) forecastList.item(i);
			// The day of the week
			String day = currentFore.getElementsByTagName("day_of_week").item(0).getAttributes()
					.item(0).getNodeValue();
			// The low temperature
			String lowTemp = currentFore.getElementsByTagName("low").item(0).getAttributes()
					.item(0).getNodeValue();
			// The high temperature
			String highTemp = currentFore.getElementsByTagName("high").item(0).getAttributes()
					.item(0).getNodeValue();
			// The associated icon
			String icon = currentFore.getElementsByTagName("icon").item(0).getAttributes().item(0)
					.getNodeValue();
			// Build the associated forcast
			Forecast f = new Forecast();       
			f.setDay(day);
			f.setLowTemp(lowTemp);
			f.setHighTemp(highTemp);
			f.setIcon(icon);
			// add it to the forcasts list
			forecasts.add(f);
		}
	}
}

/** The forcast object definition **/

class Forecast {
	String day = "";
	Integer lowTemp = null;
	Integer highTemp = null;
	String iconUrl = "";

	String getDay() {
		return (day);
	}

	void setDay(String day) {
		this.day = day;
	}

	Integer getLowTemp() {
		return (lowTemp);
	}

	void setLowTemp(String temp) {
		this.lowTemp = (int) ((Float.parseFloat(temp) - 32) * 5 / 9);
	}

	Integer getHighTemp() {
		return (highTemp);
	}

	void setHighTemp(String temp) {
		this.highTemp = (int) ((Float.parseFloat(temp) - 32) * 5 / 9);
	}

	String getIcon() {
		return ("http://www.google.com" + iconUrl);
	}

	void setIcon(String iconUrl) {
		this.iconUrl = iconUrl;
	}
}
